diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPlayer.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPlayer.java
index 0a7a0c9d7..2a77e8ebb 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPlayer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPlayer.java
@@ -1,19 +1,16 @@
 package net.minecraft.client.render.entity;
 
 import net.minecraft.client.Minecraft;
-
-import net.minecraft.client.render.TileEntityRenderDispatcher;
 import net.minecraft.client.render.Lighting;
 import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.PlayerSkinParser;
+import net.minecraft.client.render.TileEntityRenderDispatcher;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
-import net.minecraft.client.render.font.FontRenderer;
-import net.minecraft.client.render.tileentity.TileEntityRenderer;
 import net.minecraft.client.render.camera.EntityCamera;
-import net.minecraft.client.render.model.ModelPlayer;
-import net.minecraft.client.render.model.ModelPlayerSlim;
+import net.minecraft.client.render.font.FontRenderer;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.client.render.tileentity.TileEntityRenderer;
 import net.minecraft.core.Global;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.motion.CarriedBlock;
@@ -21,54 +18,54 @@ import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.player.gamemode.Gamemode;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.BlocksContainer;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
+import org.useless.dragonfly.models.entity.StaticEntityModel;
 
 public class MobRendererPlayer extends MobRendererBipedArmored<Player>
 {
-    private final ModelPlayer modelThick;
-    private final ModelPlayer modelSlim;
-
     private BlocksContainer container = null;
 
     public MobRendererPlayer()
     {
-        super(new ModelPlayer(0.0F), 0.5F);
-        modelThick = new ModelPlayer(0.0f);
-        modelSlim = new ModelPlayerSlim(0.0f);
+        super(0.5F);
+    }
+
+    protected @NotNull StaticEntityModel getActiveModel(final @NotNull Player player, final boolean onlyArms) {
+        if (onlyArms) {
+            return player.slimModel ? getModel("arms.slim") : getModel("arms");
+        } else {
+            return player.slimModel ? getModel("main.slim") : getModel("main");
+        }
     }
 
-    public void drawFirstPersonHand(Player player, boolean isLeft)
+    public void drawFirstPersonHand(final @NotNull Tessellator tessellator, final @NotNull Player player, final boolean isLeft)
     {
-        mainModel = player.slimModel ? modelSlim : modelThick;
-        modelBipedMain = player.slimModel ? modelSlim : modelThick;
+        // TODO rework the transform nightmare that surround these method calls
+        final StaticEntityModel activeModel = getActiveModel(player, true);
+        activeModel.resetBones();
+
+        activeModel.getTransform("leftSleeve").visible = player.playerConfig.sleeveLeftEnabled();
+        activeModel.getTransform("rightSleeve").visible = player.playerConfig.sleeveRightEnabled();
 
-        modelBipedMain.swingProgress = 0.0F;
-        modelBipedMain.isRiding = false;
-        modelBipedMain.setupAnimation(player, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0625F, 1f);
         if (isLeft){
-            modelBipedMain.armLeft.render(0.0625F);
+            activeModel.getTransform("rightArm").visible = false;
         } else {
-            modelBipedMain.armRight.render(0.0625F);
-        }
-        if (modelBipedMain instanceof ModelPlayer)
-        {
-            if (isLeft){
-                ((ModelPlayer)modelBipedMain).bipedLeftArmOverlay.render(0.0625F);
-            } else {
-                ((ModelPlayer)modelBipedMain).bipedRightArmOverlay.render(0.0625F);
-            }
+            activeModel.getTransform("leftArm").visible = false;
         }
+        activeModel.render(tessellator);
     }
 
-    public void drawHeldObject(Player player, float partialTick) {
+    public void drawHeldObject(final Player player, final float partialTick) {
         if (player.getHeldObject() instanceof CarriedBlock) {
-            CarriedBlock carriedBlock = (CarriedBlock)player.getHeldObject();
-            if (container == null || container.world != player.world) {
-                container = new BlocksContainer(player.world);
+            final CarriedBlock carriedBlock = (CarriedBlock)player.getHeldObject();
+            if (this.container == null || this.container.world != player.world) {
+                this.container = new BlocksContainer(player.world);
             }
 
-            Tessellator tessellator = Tessellator.instance;
-            Minecraft mc = Minecraft.getMinecraft();
+            final Tessellator tessellator = Tessellator.instance;
+            final Minecraft mc = Minecraft.getMinecraft();
             TextureRegistry.blockAtlas.bind();
             GL11.glPushMatrix();
             Lighting.disable();
@@ -84,22 +81,22 @@ public class MobRendererPlayer extends MobRendererBipedArmored<Player>
             GL11.glScalef(0.55f, -0.55f, 0.55f);
             GL11.glTranslatef(0, -0.75f, -0.75f);
 
-            int blockX = MathHelper.floor(player.x);
-            int blockY = MathHelper.floor(player.y) + 1;
-            int blockZ = MathHelper.floor(player.z);
+            final int blockX = MathHelper.floor(player.x);
+            final int blockY = MathHelper.floor(player.y) + 1;
+            final int blockZ = MathHelper.floor(player.z);
 
             tessellator.startDrawingQuads();
             tessellator.setTranslation(-blockX -0.5, -blockY -0.5, -blockZ -0.5);
 
-            container.setLightReferenceEntity(player);
-            container.setBlock(blockX, blockY, blockZ, carriedBlock.blockId, carriedBlock.metadata, carriedBlock.entity);
-            BlockModelDispatcher.getInstance().getDispatch(carriedBlock.block()).renderNoCulling(Tessellator.instance, container, blockX, blockY, blockZ);
+            this.container.setLightReferenceEntity(player);
+            this.container.setBlock(blockX, blockY, blockZ, carriedBlock.blockId, carriedBlock.metadata, carriedBlock.entity);
+            BlockModelDispatcher.getInstance().getDispatch(carriedBlock.block()).renderNoCulling(Tessellator.instance, this.container, blockX, blockY, blockZ);
             tessellator.draw();
             tessellator.setTranslation(0, 0, 0);
-            container.setLightReferenceEntity(null);
-            container.clear();
+            this.container.setLightReferenceEntity(null);
+            this.container.clear();
 
-            TileEntityRenderer<TileEntity> renderer = TileEntityRenderDispatcher.instance.getRenderer(carriedBlock.entity);
+            final TileEntityRenderer<TileEntity> renderer = TileEntityRenderDispatcher.instance.getRenderer(carriedBlock.entity);
             if (renderer != null) {
                 carriedBlock.entity.worldObj = player.world;
                 renderer.doRender(tessellator, carriedBlock.entity, -0.5, -0.5, -0.5, partialTick);
@@ -111,24 +108,24 @@ public class MobRendererPlayer extends MobRendererBipedArmored<Player>
         }
     }
     @Override
-    protected void renderSpecials(Tessellator t, Player entity, double x, double y, double z)
+    protected void renderSpecials(final @NotNull Tessellator t, final @NotNull Player entity, final double x, final double y, final double z)
     {
         if (Minecraft.getMinecraft().thePlayer.getGamemode() != Gamemode.spectator && entity.getGamemode() == Gamemode.spectator) {
             return;
         }
-        if(Minecraft.getMinecraft().gameSettings.immersiveMode.drawNames() && renderDispatcher.camera != null) // Render name
+        if(Minecraft.getMinecraft().gameSettings.immersiveMode.drawNames() && this.renderDispatcher.camera != null) // Render name
         {
-            if (renderDispatcher.camera instanceof EntityCamera && ((EntityCamera)renderDispatcher.camera).mob == entity)
+            if (this.renderDispatcher.camera instanceof EntityCamera && ((EntityCamera) this.renderDispatcher.camera).mob == entity)
             {
                 return;
             }
-            float f = 1.6F;
-            float f1 = 0.01666667F * f;
-            float f2 = (float) renderDispatcher.camera.distanceTo(entity); //getting lost on renderManager.livingPlayer
-            float f3 = entity.isSneaking() ? 32F : 64F;
+            final float f = 1.6F;
+            final float f1 = 0.01666667F * f;
+            final float f2 = (float) this.renderDispatcher.camera.distanceTo(entity); //getting lost on renderManager.livingPlayer
+            final float f3 = entity.isSneaking() ? 32F : 64F;
             if(f2 < f3)
             {
-                String s = entity.getDisplayName();
+                final String s = entity.getDisplayName();
                 if(!entity.isSneaking())
                 {
                     if(entity.isPlayerSleeping())
@@ -144,8 +141,8 @@ public class MobRendererPlayer extends MobRendererBipedArmored<Player>
                     GL11.glPushMatrix();
                     GL11.glTranslatef((float) x + 0.0F, (float) y + 2.3F, (float) z);
                     GL11.glNormal3f(0.0F, 1.0F, 0.0F);
-                    GL11.glRotatef(-renderDispatcher.viewLerpYaw, 0.0F, 1.0F, 0.0F);
-                    GL11.glRotatef(renderDispatcher.viewLerpPitch, 1.0F, 0.0F, 0.0F);
+                    GL11.glRotatef(-this.renderDispatcher.viewLerpYaw, 0.0F, 1.0F, 0.0F);
+                    GL11.glRotatef(this.renderDispatcher.viewLerpPitch, 1.0F, 0.0F, 0.0F);
                     GL11.glScalef(-f1, -f1, f1);
                     GL11.glDisable(GL11.GL_LIGHTING);
                     GL11.glTranslatef(0.0F, 0.25F / f1, 0.0F);
@@ -174,32 +171,51 @@ public class MobRendererPlayer extends MobRendererBipedArmored<Player>
     }
 
     @Override
-    protected void setupScale(Player entity, float partialTick)
-    {
-        if (Minecraft.getMinecraft().thePlayer.getGamemode() == Gamemode.spectator && entity.getGamemode() == Gamemode.spectator){
-            GL11.glColor4f(1f, 1f, 1f, 0.25f);
-        } else if (entity.getGamemode() == Gamemode.spectator) {
-            GL11.glColor4f(1f, 1f, 1f, 0.0f);
+    protected void preRenderTransform(@NotNull final Player entity, final double x, final double y, final double z, final float yaw, final float partialTick) {
+        GL11.glTranslated(x, y - entity.getHeightOffset() + entity.getHeadHeight(), z); // TODO the fact that the offset for players is so fucking dumb really needs to be fixed at some point
+
+
+        if(entity.isAlive() && (entity.isPlayerSleeping())) {
+            GL11.glTranslatef(entity.sleepOffX, entity.sleepOffY, entity.sleepOffZ);
+
+            GL11.glScalef(1/ENTITY_RENDER_SCALE, 1/ENTITY_RENDER_SCALE, -1/ENTITY_RENDER_SCALE);
+            GL11.glTranslatef(0, -4.5f, 0);
+
+            GL11.glRotatef(-entity.getBedOrientationInDegrees(), 0.0F, 1.0F, 0.0F);
+            GL11.glRotatef(getMaxDeathRotation(entity), 0.0F, 0.0F, 1.0F);
+            GL11.glRotatef(270F, 0.0F, 1.0F, 0.0F);
+
+        } else {
+            GL11.glRotatef(-getBodyYaw(entity, partialTick) * MathHelper.RAD_TO_DEG, 0, 1, 0);
+            GL11.glScalef(1/ENTITY_RENDER_SCALE, 1/ENTITY_RENDER_SCALE, -1/ENTITY_RENDER_SCALE);
+        }
+
+        if(entity.deathTime > 0) {
+            float rotationProgress = (((entity.deathTime + partialTick) - 1.0F) / 20F) * 1.6F;
+            rotationProgress = MathHelper.sqrt_float(rotationProgress);
+            if(rotationProgress > 1.0F) {
+                rotationProgress = 1.0F;
+            }
+            GL11.glRotatef(rotationProgress * getMaxDeathRotation(entity), 0.0F, 0.0F, 1.0F);
         }
 
-        float scale = 0.9375F;
+
+        final float scale = 0.9375F;
         GL11.glScalef(scale, scale, scale);
 
         if (entity.isDwarf()) {
             GL11.glScalef(0.6f, 0.5f, 0.6f);
         }
+
+
     }
 
     @Override
-    protected void renderAdditional(Player player, float partialTick)
+    protected void renderAdditional(@NotNull final Tessellator tessellator, final @NotNull Player player, final float partialTick)
     {
-        if (Minecraft.getMinecraft().thePlayer.getGamemode() == Gamemode.spectator && player.getGamemode() == Gamemode.spectator){
-            GL11.glColor4f(1f, 1f, 1f, 0.25f);
-        } else if (player.getGamemode() == Gamemode.spectator) {
-            GL11.glColor4f(1f, 1f, 1f, 0.0f);
-        }
+        final StaticEntityModel activeModel = getActiveModel(player, false);
 
-        super.renderAdditional(player, partialTick);
+        super.renderAdditional(tessellator, player, partialTick);
 
         if (player.playerConfig.capeEnabled()) {
             boolean renderCape = bindDownloadableTexture("https://api.betterthanadventure.net/capes?username=" + player.username, null, null);
@@ -210,83 +226,66 @@ public class MobRendererPlayer extends MobRendererBipedArmored<Player>
 
             if(renderCape) {
                 GL11.glPushMatrix();
-                float brightness = (Global.accessor.isFullbrightEnabled() || LightmapHelper.isLightmapEnabled()) ? 1 : player.getBrightness(partialTick);
+                final float brightness = (Global.accessor.isFullbrightEnabled() || LightmapHelper.isLightmapEnabled()) ? 1 : player.getBrightness(partialTick);
                 GL11.glColor4f(brightness, brightness, brightness, 1f);
                 GL11.glTranslatef(0.0F, 0.0F, 0.125F);
-                float yawOff = player.yBodyRotO + (player.yBodyRot - player.yBodyRotO) * partialTick;
-                float bodyAngle = 5;
-                if(player.isSneaking())
-                {
-                    bodyAngle += 25F;
-                }
-                double _xd = player.xdO + (player.xd - player.xdO) * partialTick;
-                double _yd = Math.min(player.ydO + (player.yd - player.ydO) * partialTick, 0);
-                double _zd = player.zd0 + (player.zd - player.zd0) * partialTick;
-                double vel = -1/(3 * Math.hypot(_xd, _zd) + 1) + 1;
-                double moveAng = Math.atan2(_xd, _zd);
-                double yawRad = Math.toRadians(yawOff);
-                double multiplier = 1 - Math.abs((((Math.cos(yawRad) + 1) - (Math.cos(moveAng) + 1) + 2)/2) -1); // Hell code, basically measures how similar the angle you're facing is to the angle you're moving, with it returning 1 if the same angle and 0 if opposite angles
+                final float yawOff = player.yBodyRotO + (player.yBodyRot - player.yBodyRotO) * partialTick;
+                final float bodyAngle = 5;
+                final double xd = MathHelper.lerp(player.xdO, player.xd, partialTick);
+                final double yd = Math.min(MathHelper.lerp(player.ydO, player.yd, partialTick), 0);
+                final double zd = MathHelper.lerp(player.zd0, player.zd, partialTick);
+                final double vel = -1/(3 * Math.hypot(xd, zd) + 1) + 1;
+                final double moveAng = Math.atan2(xd, zd);
+                final double yawRad = Math.toRadians(yawOff);
+                final double multiplier = 1 - Math.abs((((Math.cos(yawRad) + 1) - (Math.cos(moveAng) + 1) + 2)/2) -1); // Hell code, basically measures how similar the angle you're facing is to the angle you're moving, with it returning 1 if the same angle and 0 if opposite angles
                 player.wobbleTimer += (float) (((player.tickCount + partialTick) - player.lastRenderTick)/(30 - 29 * MathHelper.clamp(vel, 0, 1)));
                 player.lastRenderTick = player.tickCount;
-                double wobble = Math.sin(player.wobbleTimer) * (1.5 + 4.5 * vel * multiplier);
-                GL11.glRotatef((float) MathHelper.clamp((MathHelper.clamp(bodyAngle + vel * 100 * multiplier, bodyAngle, 100f) + wobble) - _yd * 60, 0, 180), 1.0F, 0.0F, 0.0F);
-                GL11.glRotatef(0, 0.0F, 0.0F, 1.0F);
-                GL11.glRotatef(0, 0.0F, 1.0F, 0.0F);
-                GL11.glRotatef(180F, 0.0F, 1.0F, 0.0F);
-                modelBipedMain.renderCloak(0.0625F);
+                final double wobble = Math.sin(player.wobbleTimer) * (1.5 + 4.5 * vel * multiplier);
+                activeModel.translateToBone("cape");
+                final StaticEntityModel cape = getModel("cape");
+                cape.getTransform("cape").rotX = -MathHelper.clamp((MathHelper.clamp(bodyAngle + vel * 100 * multiplier, bodyAngle, 100f) + wobble) - yd * 60, 0, 180) * MathHelper.DEG_TO_RAD;
+                cape.render(tessellator);
                 GL11.glPopMatrix();
             }
         }
 
         if (player.getHeldObject() != null) {
-            float walkSpeed = player.walkAnimSpeedO + (player.walkAnimSpeed - player.walkAnimSpeedO) * partialTick;
-            float walkProgress = player.walkAnimPos - player.walkAnimSpeed * (1.0F - partialTick);
+            final float walkSpeed = player.walkAnimSpeedO + (player.walkAnimSpeed - player.walkAnimSpeedO) * partialTick;
+            final float walkProgress = player.walkAnimPos - player.walkAnimSpeed * (1.0F - partialTick);
             GL11.glTranslatef(0, MathHelper.cos(walkProgress/2 * 2/3f)/26f * walkSpeed + 0.1f, 0);
             drawHeldObject(player, partialTick);
         }
     }
 
     @Override
-    protected void setupRotations(Player entity, float ticksExisted, float bodyYaw, float partialTick)
-    {
-        if(entity.isAlive() && entity.isPlayerSleeping())
-        {
-            GL11.glRotatef(entity.getBedOrientationInDegrees(), 0.0F, 1.0F, 0.0F);
-            GL11.glRotatef(getMaxDeathRotation(entity), 0.0F, 0.0F, 1.0F);
-            GL11.glRotatef(270F, 0.0F, 1.0F, 0.0F);
-        } else
-        {
-            super.setupRotations(entity, ticksExisted, bodyYaw, partialTick);
-        }
+    protected @Nullable StaticEntityModel getActiveModel(@NotNull final Player entity) {
+        return entity.slimModel ? getModel("main.slim") : getModel("main");
     }
 
     @Override
-    protected void translateModel(Player entity, double x, double y, double z)
-    {
-        if(entity.isAlive() && entity.isPlayerSleeping())
-        {
-            super.translateModel(entity, x + (double)entity.sleepOffX, y + (double)entity.sleepOffY, z + (double)entity.sleepOffZ);
-        } else
-        {
-            super.translateModel(entity, x, y, z);
+    protected @Nullable StaticEntityModel getAndSetupModelForLayer(@NotNull final Player entity, final float brightness, final float partialTick, final int layer) {
+        if (layer == 0) {
+            return setupAnimations(entity, getActiveModel(entity, false), partialTick, layer);
         }
+        return super.getAndSetupModelForLayer(entity, brightness, partialTick, layer);
     }
 
     @Override
-    public void render(Tessellator tessellator, Player entity, double x, double y, double z,
-                       float yaw, float partialTick)
-    {
-        this.mainModel = entity.slimModel ? this.modelSlim : this.modelThick;
-        this.modelBipedMain = entity.slimModel ? this.modelSlim : this.modelThick;
-        this.modelArmorA.holdingLarge = this.modelArmorB.holdingLarge = this.modelBipedMain.holdingLarge = entity.getHeldObject() != null;
-        this.modelArmorA.holdingRightHand = this.modelArmorB.holdingRightHand = this.modelBipedMain.holdingRightHand |= entity.getHeldObject() != null;
-        this.modelArmorA.holdingLeftHand = this.modelArmorB.holdingLeftHand = this.modelBipedMain.holdingLeftHand |= entity.getHeldObject() != null;
-
-        super.render(tessellator, entity, x, y, z, yaw, partialTick);
+    protected @Nullable StaticEntityModel setupAnimations(@NotNull final Player entity, @Nullable final StaticEntityModel model, final float partialTick, final int layer) {
+        final StaticEntityModel model1 = super.setupAnimations(entity, model, partialTick, layer);
+        if (model1 != null && layer == 0) {
+            model1.getTransform("hat").visible = entity.playerConfig.hatEnabled();
+            model1.getTransform("jacket").visible = entity.playerConfig.jacketEnabled();
+            model1.getTransform("leftSleeve").visible = entity.playerConfig.sleeveLeftEnabled();
+            model1.getTransform("rightSleeve").visible = entity.playerConfig.sleeveRightEnabled();
+            model1.getTransform("leftPant").visible = entity.playerConfig.pantLeftEnabled();
+            model1.getTransform("rightPant").visible = entity.playerConfig.pantRightEnabled();
+        }
+        return model1;
     }
 
     @Override
-    public void loadEntityTexture(Player entity) {
+    public void loadEntityTexture(final @NotNull Player entity) {
         bindDownloadableTexture(entity.skinURL, entity.getEntityTexture(), PlayerSkinParser.instance);
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererQuadruped.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererQuadruped.java
new file mode 100644
index 000000000..e2bc5c981
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererQuadruped.java
@@ -0,0 +1,43 @@
+package net.minecraft.client.render.entity;
+
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.entity.animal.MobCow;
+import net.minecraft.core.util.helper.MathHelper;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.useless.dragonfly.models.entity.BoneTransform;
+import org.useless.dragonfly.models.entity.StaticEntityModel;
+
+public class MobRendererQuadruped<T extends Mob> extends MobRenderer<T> {
+
+    public MobRendererQuadruped(final float shadowSize) {
+        super(shadowSize);
+    }
+
+    @Override
+    protected @Nullable StaticEntityModel getAndSetupModelForLayer(@NotNull final T entity, final float brightness, final float partialTick, final int layer) {
+        final StaticEntityModel model = getModel("main");
+        model.resetBones();
+
+        final BoneTransform head = model.getTransform("head");
+        final BoneTransform leg0 = model.getTransform("leg0");
+        final BoneTransform leg1 = model.getTransform("leg1");
+        final BoneTransform leg2 = model.getTransform("leg2");
+        final BoneTransform leg3 = model.getTransform("leg3");
+
+        final float bodyYaw = getBodyYaw(entity, partialTick);
+        final float headYaw = getHeadYaw(entity, partialTick) - bodyYaw;
+        final float headPitch = getHeadPitch(entity, partialTick);
+        final float limbSwing = getLimbSwing(entity, partialTick);
+        final float limbYaw = getLimbYaw(entity, partialTick);
+
+        head.rotX = headPitch;
+        head.rotY = headYaw;
+        leg0.rotX = MathHelper.cos(limbSwing * 0.6662F) * 1.4F * limbYaw;
+        leg1.rotX = MathHelper.cos(limbSwing * 0.6662F + MathHelper.PI) * 1.4F * limbYaw;
+        leg2.rotX = MathHelper.cos(limbSwing * 0.6662F + MathHelper.PI) * 1.4F * limbYaw;
+        leg3.rotX = MathHelper.cos(limbSwing * 0.6662F) * 1.4F * limbYaw;
+
+        return model;
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererScorpion.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererScorpion.java
index 77841ed69..2eb2f30d1 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererScorpion.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererScorpion.java
@@ -1,30 +1,51 @@
 package net.minecraft.client.render.entity;
 
-import net.minecraft.client.render.model.ModelScorpion;
 import net.minecraft.core.entity.monster.MobScorpion;
+import net.minecraft.core.util.helper.MathHelper;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.useless.dragonfly.models.entity.BoneTransform;
+import org.useless.dragonfly.models.entity.StaticEntityModel;
 
-public class MobRendererScorpion extends MobRenderer<MobScorpion>
-{
+public class MobRendererScorpion extends MobRenderer<MobScorpion> {
 
-    public MobRendererScorpion()
-    {
-        super(new ModelScorpion(), 0.5F);
-        setArmorModel(new ModelScorpion());
-    }
-    protected boolean doRenderPass(MobScorpion scorpion, int i, float f)
-    {
-        return i == 0;
+    public MobRendererScorpion(final float shadowSize) {
+        super(shadowSize);
     }
 
     @Override
-    protected float getMaxDeathRotation(MobScorpion entity)
-    {
-        return 180F;
+    protected @Nullable StaticEntityModel getAndSetupModelForLayer(@NotNull final MobScorpion entity, final float brightness, final float partialTick, final int layer) {
+        final StaticEntityModel model = getModel("main");
+        model.resetBones();
+
+        final float limbSwing = getLimbSwing(entity, partialTick);
+        final float limbYaw = getLimbYaw(entity, partialTick);
+
+        final BoneTransform leg0 = model.getTransform("leg0");
+        final BoneTransform leg1 = model.getTransform("leg1");
+        final BoneTransform leg2 = model.getTransform("leg2");
+        final BoneTransform leg3 = model.getTransform("leg3");
+        final BoneTransform leg4 = model.getTransform("leg4");
+        final BoneTransform leg5 = model.getTransform("leg5");
+
+        final float pair1Y = -(MathHelper.cos(limbSwing * 0.6662F * 2.0F + 0.0F) * 0.4F) * limbYaw;
+        final float pair2Y = -(MathHelper.cos(limbSwing * 0.6662F * 2.0F + MathHelper.PI) * 0.4F) * limbYaw;
+        final float pair3Y = -(MathHelper.cos(limbSwing * 0.6662F * 2.0F + MathHelper.PI / 2F) * 0.4F) * limbYaw;
+
+        leg0.rotZ = leg2.rotZ = leg4.rotZ = -22.5 * MathHelper.DEG_TO_RAD;
+        leg0.rotY = 30 * MathHelper.DEG_TO_RAD - pair2Y;
+        leg2.rotY = 0 + pair3Y;
+        leg4.rotY = -30 * MathHelper.DEG_TO_RAD + pair2Y;
+
+        leg1.rotZ = leg3.rotZ = leg5.rotZ = 22.5 * MathHelper.DEG_TO_RAD;
+        leg1.rotY = -30 * MathHelper.DEG_TO_RAD + pair1Y;
+        leg3.rotY = 0 - pair3Y;
+        leg5.rotY = 30 * MathHelper.DEG_TO_RAD - pair1Y;
+        return model;
     }
 
     @Override
-    protected boolean prepareArmor(MobScorpion entity, int renderPass, float partialTick)
-    {
-        return doRenderPass(entity, renderPass, partialTick);
+    protected float getMaxDeathRotation(@NotNull final MobScorpion entity) {
+        return 180;
     }
 }
